#include <cms.h>
#include "Set_DispData.h"
#include "Display_LCD.h"

/********************************************
ƣDisplay_LCD
ܣ趨ʾݽʾ
ڲ
ڲ
*********************************************/

void Display_LCD(void)
{
	LCDCON = 0B10000001;			//ʹLCD, 1/2ƫѹ200uA

	CSEN0  = 0B00001111;			//ӦIO RA3-RA0 ΪLCDCOM

	TRISA  = 0B00001111;			//ӦCOM RA3-RA0 Ϊ̬
	
	CSEN1  = 0B11111111;			//ӦIO RB7-RB0 ΪLCDSEG
	
	TRISB  = 0B00000000;			//ӦSEG RB7-RB0 Ϊ̬
	
	if(Dcount & 0x01)				//Ƚʾر
	{
		P_SEG1 = 1;
		P_SEG2 = 1;
		P_SEG3 = 1;
		P_SEG4 = 1;
		P_SEG5 = 1;
		P_SEG6 = 1;												
		P_SEG7 = 1;
		P_SEG8 = 1;
	}
	else
	{
		P_SEG1 = 0;
		P_SEG2 = 0;
		P_SEG3 = 0;
		P_SEG4 = 0;
		P_SEG5 = 0;
		P_SEG6 = 0;												
		P_SEG7 = 0;
		P_SEG8 = 0;		
	}	
	
	//ѭCOM
	switch(Dcount)	
	{
		case 0:
			P_COM1 = 0;
			CSEN0  = 0B00001110;		//ʹP_COM1ΪͨIO
			TRISA  = 0B00001110;		//P_COM1Ϊ̬
			P_COM1 = 0;
			
			if(Smg_Data1 & 0x01)	{P_SEG1 = 1;}
			if(Smg_Data1 & 0x02)	{P_SEG2 = 1;}
			if(Smg_Data1 & 0x04)	{P_SEG3 = 1;}
			if(Smg_Data1 & 0x08)	{P_SEG4 = 1;}
			if(Smg_Data1 & 0x10)	{P_SEG5 = 1;}
			if(Smg_Data1 & 0x20)	{P_SEG6 = 1;}
			if(Smg_Data1 & 0x40)	{P_SEG7 = 1;}
			if(Smg_Data1 & 0x80)	{P_SEG8 = 1;}
			break;
		case 1:
			P_COM1 = 1;
			CSEN0  = 0B00001110;		//ʹP_COM1ΪͨIO
			TRISA  = 0B00001110;		//P_COM1Ϊ̬
			P_COM1 = 1;
			
			if(Smg_Data1 & 0x01)	{P_SEG1 = 0;}
			if(Smg_Data1 & 0x02)	{P_SEG2 = 0;}
			if(Smg_Data1 & 0x04)	{P_SEG3 = 0;}
			if(Smg_Data1 & 0x08)	{P_SEG4 = 0;}
			if(Smg_Data1 & 0x10)	{P_SEG5 = 0;}
			if(Smg_Data1 & 0x20)	{P_SEG6 = 0;}
			if(Smg_Data1 & 0x40)	{P_SEG7 = 0;}
			if(Smg_Data1 & 0x80)	{P_SEG8 = 0;}																				 
			break;
		case 2:
			P_COM2 = 0;
			CSEN0  = 0B00001101;		//ʹP_COM2ΪͨIO
			TRISA  = 0B00001101;		//P_COM2Ϊ̬
			P_COM2 = 0;
			
			if(Smg_Data2 & 0x01)	{P_SEG1 = 1;}
			if(Smg_Data2 & 0x02)	{P_SEG2 = 1;}
			if(Smg_Data2 & 0x04)	{P_SEG3 = 1;}
			if(Smg_Data2 & 0x08)	{P_SEG4 = 1;}
			if(Smg_Data2 & 0x10)	{P_SEG5 = 1;}
			if(Smg_Data2 & 0x20)	{P_SEG6 = 1;}
			if(Smg_Data2 & 0x40)	{P_SEG7 = 1;}
			if(Smg_Data2 & 0x80)	{P_SEG8 = 1;}																				 
			break;
		case 3:
			P_COM2 = 1;
			CSEN0  = 0B00001101;		//ʹP_COM2ΪͨIO
			TRISA  = 0B00001101;		//P_COM2Ϊ̬
			P_COM2 = 1;
			
			if(Smg_Data2 & 0x01)	{P_SEG1 = 0;}
			if(Smg_Data2 & 0x02)	{P_SEG2 = 0;}
			if(Smg_Data2 & 0x04)	{P_SEG3 = 0;}
			if(Smg_Data2 & 0x08)	{P_SEG4 = 0;}
			if(Smg_Data2 & 0x10)	{P_SEG5 = 0;}
			if(Smg_Data2 & 0x20)	{P_SEG6 = 0;}
			if(Smg_Data2 & 0x40)	{P_SEG7 = 0;}
			if(Smg_Data2 & 0x80)	{P_SEG8 = 0;}																				 
			break;
		case 4:
			P_COM3 = 0;
			CSEN0  = 0B00001011;		//ʹP_COM3ΪͨIO
			TRISA  = 0B00001011;		//P_COM3Ϊ̬
			P_COM3 = 0;
			
			if(Smg_Data3 & 0x01)	{P_SEG1 = 1;}
			if(Smg_Data3 & 0x02)	{P_SEG2 = 1;}
			if(Smg_Data3 & 0x04)	{P_SEG3 = 1;}
			if(Smg_Data3 & 0x08)	{P_SEG4 = 1;}
			if(Smg_Data3 & 0x10)	{P_SEG5 = 1;}
			if(Smg_Data3 & 0x20)	{P_SEG6 = 1;}
			if(Smg_Data3 & 0x40)	{P_SEG7 = 1;}
			if(Smg_Data3 & 0x80)	{P_SEG8 = 1;}																				 
			break;
		case 5:
			P_COM3 = 1;
			CSEN0  = 0B00001011;		//ʹP_COM3ΪͨIO
			TRISA  = 0B00001011;		//P_COM3Ϊ̬
			P_COM3 = 1;
			
			if(Smg_Data3 & 0x01)	{P_SEG1 = 0;}
			if(Smg_Data3 & 0x02)	{P_SEG2 = 0;}
			if(Smg_Data3 & 0x04)	{P_SEG3 = 0;}
			if(Smg_Data3 & 0x08)	{P_SEG4 = 0;}
			if(Smg_Data3 & 0x10)	{P_SEG5 = 0;}
			if(Smg_Data3 & 0x20)	{P_SEG6 = 0;}
			if(Smg_Data3 & 0x40)	{P_SEG7 = 0;}
			if(Smg_Data3 & 0x80)	{P_SEG8 = 0;}
			break;	
		case 6:
			P_COM4 = 0;
			CSEN0  = 0B00000111;		//ʹP_COM4ΪͨIO
			TRISA  = 0B00000111;		//P_COM4Ϊ̬
			P_COM4 = 0;
			
			if(Smg_Data4 & 0x01)	{P_SEG1 = 1;}
			if(Smg_Data4 & 0x02)	{P_SEG2 = 1;}
			if(Smg_Data4 & 0x04)	{P_SEG3 = 1;}
			if(Smg_Data4 & 0x08)	{P_SEG4 = 1;}
			if(Smg_Data4 & 0x10)	{P_SEG5 = 1;}
			if(Smg_Data4 & 0x20)	{P_SEG6 = 1;}
			if(Smg_Data4 & 0x40)	{P_SEG7 = 1;}
			if(Smg_Data4 & 0x80)	{P_SEG8 = 1;}
			break;
		default:
			P_COM4 = 1;
			CSEN0  = 0B00000111;		//ʹP_COM4ΪͨIO
			TRISA  = 0B00000111;		//P_COM4Ϊ̬
			P_COM4 = 1;
			
			if(Smg_Data4 & 0x01)	{P_SEG1 = 0;}
			if(Smg_Data4 & 0x02)	{P_SEG2 = 0;}
			if(Smg_Data4 & 0x04)	{P_SEG3 = 0;}
			if(Smg_Data4 & 0x08)	{P_SEG4 = 0;}
			if(Smg_Data4 & 0x10)	{P_SEG5 = 0;}
			if(Smg_Data4 & 0x20)	{P_SEG6 = 0;}
			if(Smg_Data4 & 0x40)	{P_SEG7 = 0;}
			if(Smg_Data4 & 0x80)	{P_SEG8 = 0;}	
			break;
	}
	
	if(++Dcount >= 8)
	{
		Dcount = 0;
	}
}